/***************************************************************************
 *   copyright       : (C) 2009-2010 by Pascal Brachet                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "affectationdialog.h"

#include <QMessageBox>
#include <QFile>
#include <QTextStream>
#include <QTextCodec>

AffectationDialog::AffectationDialog(QWidget *parent, QString variables, QString types )
    :QDialog( parent)
{
ui.setupUi(this);
setModal(true);

QTextCodec *codec = QTextCodec::codecForName("UTF-8");
QString contenu;
QFile aide(":/documents/aideaffectation.txt");
aide.open(QIODevice::ReadOnly);
QTextStream in(&aide);
in.setCodec(codec);
while (!in.atEnd()) 
	{
	contenu+= in.readLine()+"\n";
	}
aide.close();
ui.textEdit->setHtml(contenu);

listeVariables=variables.split("#");
listeTypes=types.split("#");

for (int i = 0; i < listeVariables.count(); i++)
{
  if (listeTypes.at(i)=="LISTE") listeVarListe.append(listeVariables.at(i)+"[]");
  else if (listeTypes.at(i)=="NOMBRE") listeVarNombre.append(listeVariables.at(i));
  else if (listeTypes.at(i)=="CHAINE") listeVarChaine.append(listeVariables.at(i));
}

ui.comboBoxAffectation->addItems(listeVariables);
ui.labelAffectation3->setEnabled(false);
ui.lineEditAffectation2->setEnabled(false);
if (ui.comboBoxAffectation->count()>0) ActualiserWidget(ui.comboBoxAffectation->currentIndex());
connect(ui.comboBoxAffectation, SIGNAL(activated(int)),this,SLOT(ActualiserWidget(int)));
connect(ui.listWidget, SIGNAL(itemClicked ( QListWidgetItem*)), this, SLOT(InsertVariable(QListWidgetItem*)));
}

AffectationDialog::~AffectationDialog(){
}

void AffectationDialog::accept()
{
if ( ui.lineEditAffectation2->isEnabled() && ui.lineEditAffectation2->text().isEmpty()) 
	{
	QMessageBox::warning( this,QString::fromUtf8("Erreur"),QString::fromUtf8("Rectifiez le rang du terme de la liste : il est vide"));
	return;
	}
if (listeTypes.at(ui.comboBoxAffectation->currentIndex())!="CHAINE" && ui.lineEditAffectation->text().contains("="))
	{
	QMessageBox::warning( this,QString::fromUtf8("Erreur"),QString::fromUtf8("Le caractère '=' n'est pas autorisé dans une affectation."));
	return;
	}
QDialog::accept();
}

void AffectationDialog::ActualiserWidget(int index)
{
ui.listWidget->clear();
if (listeTypes.at(index)=="LISTE")
    {
    ui.lineEditAffectation2->clear();
    ui.labelAffectation3->setEnabled(true);
    ui.lineEditAffectation2->setEnabled(true);
    if (listeVarNombre.count()>0) ui.listWidget->addItems(listeVarNombre);
    if (listeVarListe.count()>0) ui.listWidget->addItems(listeVarListe);
    }
else if (listeTypes.at(index)=="NOMBRE")
    {
    ui.lineEditAffectation2->clear();
    ui.labelAffectation3->setEnabled(false);
    ui.lineEditAffectation2->setEnabled(false);
    if (listeVarNombre.count()>0) ui.listWidget->addItems(listeVarNombre);
    if (listeVarListe.count()>0) ui.listWidget->addItems(listeVarListe);
    }
else if (listeTypes.at(index)=="CHAINE")
    {
    ui.lineEditAffectation2->clear();
    ui.labelAffectation3->setEnabled(false);
    ui.lineEditAffectation2->setEnabled(false);
    if (listeVarChaine.count()>0) ui.listWidget->addItems(listeVarChaine);
    }
}

void AffectationDialog::InsertVariable(QListWidgetItem *item)
{
QString txt=item->text();
int pos=ui.lineEditAffectation->cursorPosition();
ui.lineEditAffectation->insert(txt);
ui.lineEditAffectation->setCursorPosition(pos+txt.length());
ui.lineEditAffectation->setFocus();
}